/***********************************************************
 * $Id: fancylogdLog.h 1731 2015-09-03 10:40:24Z fancylibs $
 *
 * ATOS client - ATOS client modules
 *
 * Copyright (C) 2014 EFKON AG http://www.efkon.com
 *
 * Developed by ITEG IT-Engineers GmbH http://www.iteg.at
 *
 ************************************************************/

#ifndef FANCYLOGD_LOG_H
#define FANCYLOGD_LOG_H

#include <fancylogdCommon.h>
#include <fancylog.h>

// facility masks:
// facility "fancylogd-common"
#define  FANCYLOGD_LOG_COMMON            (1<<0)
// facility "fancylogd-client"
#define  FANCYLOGD_LOG_CLIENT            (1<<1)
// facility "fancylogd"
#define  FANCYLOGD_LOG_DAEMON            (1<<2)
// facility "fancylogd-testclient"
#define  FANCYLOGD_LOG_TESTCLIENT        (1<<3)

namespace Fancy { namespace LogD {

	extern FANCYLOGD_COMMON_API fancylog_service *log_service;

    // parse for logging cmdline args and filter out recognized options.
    void FANCYLOGD_COMMON_API fancylog_parse_arg (int *argc, char **argv);

    inline void vfancylog (int facility,
                           int priority, const char *fmt, va_list ap)
      {
        va_list aq;
        va_copy(aq,ap);
        ::vfancylog(log_service,facility,priority,fmt,aq);
        va_end(aq);
      }

#ifdef __GNUG__
  inline void fancylog (int facility,
                        int priority, const char *fmt, ...)
    __attribute__((format(printf,3,4)));

#endif

    inline void fancylog (int facility,
                          int priority, const char *fmt, ...)
      {
        va_list ap;
        va_start(ap, fmt);
        vfancylog(facility,priority,fmt,ap);
        va_end(ap);
      }
}}

#endif // ! FANCYLOGD_LOG_H
